//---------------------------------------------------------------------------
#pragma hdrstop

#include "BVetor2D.h"
#include <math.h>
//---------------------------------------------------------------------------
BVetor2D::BVetor2D(void)
{
    x = 0;
    y = 0;
}
//---------------------------------------------------------------------------
BVetor2D::BVetor2D(double xx, double yy)
{
    x = xx;
    y = yy;
}
//---------------------------------------------------------------------------
BVetor2D::BVetor2D(const BVetor2D& v)
{
    x = v.x;
    x = v.y;
}
//---------------------------------------------------------------------------
BVetor2D::~BVetor2D(void)
{

}
//---------------------------------------------------------------------------
BVetor2D& BVetor2D::operator = (const BVetor2D& v)
{
    x = v.x;
    y = v.y;
    return *this;
}
//---------------------------------------------------------------------------
bool BVetor2D::operator == (const BVetor2D& v)
{
    return (x == v.x) && (y == v.y);
}
//---------------------------------------------------------------------------
bool BVetor2D::operator != (const BVetor2D& v)
{
    return (x != v.x) || (y != v.y);
}
//---------------------------------------------------------------------------
BVetor2D& BVetor2D::operator += (const BVetor2D& v)
{
    x += v.x;
    y += v.y;
    return *this;
}
//---------------------------------------------------------------------------
BVetor2D& BVetor2D::operator += (double d)
{
    x += d;
    y += d;
    return *this;
}
//---------------------------------------------------------------------------
BVetor2D& BVetor2D::operator -= (const BVetor2D& v)
{
    x -= v.x;
    y -= v.y;
    return *this;
}
//---------------------------------------------------------------------------
BVetor2D& BVetor2D::operator -= (double d)
{
    x -= d;
    y -= d;
    return *this;
}
//---------------------------------------------------------------------------
BVetor2D& BVetor2D::operator *= (double d)
{
    x *= d;
    y *= d;
    return *this;
}
//---------------------------------------------------------------------------
BVetor2D& BVetor2D::operator /= (double d)
{
    x /= d;
    y /= d;
    return *this;
}
//---------------------------------------------------------------------------
BVetor2D operator + (const BVetor2D& v1, const BVetor2D& v2)
{
    return BVetor2D(v1.x + v2.x, v1.y + v2.y);
}
//---------------------------------------------------------------------------
BVetor2D operator + (double d, const BVetor2D& v)
{
    return BVetor2D(v.x + d, v.y + d);
}
//---------------------------------------------------------------------------
BVetor2D operator + (const BVetor2D& v, double d)
{
    return BVetor2D(v.x + d, v.y + d);
}
//---------------------------------------------------------------------------
BPonto2D operator + (const BPonto2D& p, const BVetor2D& v)
{
    return BPonto2D(v.x + p.X(), v.y + p.Y());
}
//---------------------------------------------------------------------------
BVetor2D operator - (const BPonto2D& p1, const BPonto2D& p2)
{
    return BVetor2D(p1.X() - p2.X(), p1.Y() - p2.Y());
}
//---------------------------------------------------------------------------
BVetor2D operator - (const BVetor2D& v1, const BVetor2D& v2)
{
    return BVetor2D(v1.x - v2.x, v1.y - v2.y);
}
//---------------------------------------------------------------------------
BVetor2D operator - (const BVetor2D& v, double d)
{
    return BVetor2D(v.x - d, v.y - d);
}
//---------------------------------------------------------------------------
double operator * (const BVetor2D& v1, const BVetor2D& v2)
{
    return v1.x * v2.x + v1.y * v2.y;
}
//---------------------------------------------------------------------------
BVetor2D operator * (double d, const BVetor2D& v)
{
    return BVetor2D(v.x * d, v.y * d);
}
//---------------------------------------------------------------------------
BVetor2D operator * (const BVetor2D& v, double d)
{
    return BVetor2D(v.x * d, v.y * d);
}
//---------------------------------------------------------------------------
BVetor2D operator / (const BVetor2D& v, double d)
{
    if(d == 0)
    {
        throw;
    }
    return BVetor2D(v.x / d, v.y / d);
}
//---------------------------------------------------------------------------
void BVetor2D::DefCoordenadas(double xx, double yy)
{
    x = xx;
    y = yy;
}
//---------------------------------------------------------------------------
double abs(const BVetor2D& v)
{
    return sqrt(v.x * v.x + v.y * v.y);
}
//---------------------------------------------------------------------------
BVetor2D Unitario(const BVetor2D& v)
{
    double mod = abs(v);

    if(mod == 0)
    {
        throw;
    }
    return BVetor2D(v.x / mod, v.y / mod);
}
//---------------------------------------------------------------------------

